#include "headers.h"
Mix_Chunk *se[2];
efectBaku eft;//爆発エフェクト

//------------------------------------------------------------------------------自弾と敵機の当たり判定
void hitChek_meB(int lop)
{
int blt;//表示中の自弾を探す
for(blt=0;blt<bltMax;blt++)
if(mes.flgB[blt]==1)
	{
	SDL_Rect R1,R2;
	//敵の座標と大きさ設定
	R1.x=ene[lop].posX;	R1.y=ene[lop].posY; R1.w=20; R1.h=20;
	//自弾の座標と大きさ設定
	R2.x=mes.bltX[blt]; R2.y=mes.bltY[blt]; R2.w=2;	R2.h=24;
	
	//当り判定、当たってたらフラグ下げる
	if(	((R1.x)<(R2.x+R2.w))	&& ((R2.x)<(R1.x+R1.w))&&((R1.y)<(R2.y+R2.h))	&& ((R2.y)<(R1.y+R1.h))	)
		{
		ene[lop].flg=0;//敵フラグ
		mes.flgB[blt]=0;//自弾フラグ
		playSE(1);//効果音
		efect_init(ene[lop].posX,ene[lop].posY,ene[lop].spd);//爆発エフェクト初期化
		break;
		}
	}
}
//------------------------------------------------------------------------------自機と敵機の当たり判定
void hitChek_eneM(int lop)
{
SDL_Rect R1,R2;
//敵の座標と大きさ設定
R1.x=ene[lop].posX;	R1.y=ene[lop].posY; R1.w=20; R1.h=20;
//自機の座標と大きさ設定
R2.x=mes.posX+8; R2.y=mes.posY+8; R2.w=4;	R2.h=8;

//当り判定、当たってたらフラグ下げる
if(	((R1.x)<(R2.x+R2.w))	&& ((R2.x)<(R1.x+R1.w))&&((R1.y)<(R2.y+R2.h))	&& ((R2.y)<(R1.y+R1.h))	)
	{
	games=2;//ゲームオーバー画面へ
	otr.time=timer.now;//接触時間取得
	playSE(1);//効果音
	}
}
//------------------------------------------------------------------------------敵弾と自機の当たり判定
void hitChek_Blt(int lop)
{
SDL_Rect R1,R2;
//敵弾の座標と大きさ設定
R1.x=tama[lop].posX;	R1.y=tama[lop].posY; R1.w=4; R1.h=12;
//自機の座標と大きさ設定
R2.x=mes.posX+8; R2.y=mes.posY+8; R2.w=4;	R2.h=8;

//当り判定、当たってたらフラグ下げる
if(	((R1.x)<(R2.x+R2.w))	&& ((R2.x)<(R1.x+R1.w))&&((R1.y)<(R2.y+R2.h))	&& ((R2.y)<(R1.y+R1.h))	)
	{
	games=2;//ゲームオーバー画面へ
	otr.time=timer.now;//接触時間取得
	playSE(1);//効果音
	}
}
//------------------------------------------------------------------------------音ファイル読み込み
void loadSounds()
{
//設定
if(Mix_OpenAudio(44100,MIX_DEFAULT_FORMAT,2,1024)==-1)SDL_Quit();
//読み込み
se[0]=Mix_LoadWAV("inbeida.app/Contents/Resources/se0.aif");
se[1]=Mix_LoadWAV("inbeida.app/Contents/Resources/se1.aif");
}
//------------------------------------------------------------------------------効果音鳴らす
void playSE(int num)
{
Mix_PlayChannel(num, se[num], 0);
}
//------------------------------------------------------------------------------爆発エフェクト初期化用
void efect_init(Sint16 posX,Sint16 posY,Sint16 spd)
{
int lop;
for(lop=0;		lop<efcMax;		lop++) 
if(eft.flg[lop]==0)
	{
	eft.flg[lop]=1;//フラグオン
	eft.posX[lop]=posX-30;//敵機の位置格納
	eft.posY[lop]=posY-30;
	eft.cnt[lop]=0;
	eft.spd[lop]=spd;
	break;//ループ抜ける
	}
}
//------------------------------------------------------------------------------爆発エフェクト表示
void efect_main()
{
int lop;
for(lop=0;		lop<efcMax;		lop++) 
if(eft.flg[lop]>=1)
	{
	SDL_Rect efe;//描画矩形用
	//移動量計算
	eft.posX[lop]+=eft.spd[lop];
	eft.posY[lop]++;
	//座標＆大きさ代入
	efe.x=eft.posX[lop]+rand()%50;
	efe.y=eft.posY[lop]+rand()%50;
	efe.w=1+rand()%30; efe.h=1+rand()%30;
	//敵の点滅表示
	if(eft.cnt[lop]<3)eft.cnt[lop]++;
	else
		{
		ene_src(0,eft.posX[lop]+30,eft.posY[lop]+30);
		eft.cnt[lop]=0;
		}
	//色決定し爆発表示
	Uint8 R=rand()%255;
	Uint8 G=rand()%255;
	SDL_FillRect(mWIN,&efe,SDL_MapRGB(mWIN->format,R,G,255));
	//表示カウンタ
	if(eft.flg[lop]<120)eft.flg[lop]++;
	else eft.flg[lop]=0;//フラグ下げる
	}
}